<?php
class IEMus {

    function __construct() {

    }

    /*
     * Add menu to admin page
     */
    function iemus_add_menu() {
        global $wpdb;
        $plugin_page = false;
        if (function_exists('is_super_admin') && is_super_admin()){
            $plugin_page = add_submenu_page('wpmu-admin.php', 'IEM User Subscription', 'IEM User Subscription 2.1', 10, 'iem', array($this, 'iemus_setting_page'));
        } elseif (!function_exists('is_super_admin') ) {
            $plugin_page = add_submenu_page('tools.php', 'IEM User Subscription', 'IEM User Subscription 2.1', 10, 'iem', array($this, 'iemus_setting_page'));
        }
        if($plugin_page) {
            add_filter( 'admin_footer_text', array($this, 'admin_footer') );
        }
    }

    function admin_footer() {
        return "Copyright &copy; <a href='http://www.iemaddons.com/' target='blank' title='IEMAddons.com'>IEMAddons.com</a>";
    }

    /*
     * Admin setting page
     */
    function iemus_setting_page() {

        global $wpdb,  $current_user;

        //if it's not admin, don't show anything
        if ( function_exists('is_super_admin') && !is_super_admin())
            return;

        if (isset($_GET['updated'])) {
            ?><div id="message" class="updated fade"><p><?php _e('' . urldecode($_GET['updatedmsg']) . '') ?></p></div><?php
        }

        echo '<div class="wrap">';

        switch( $_GET[ 'action' ] ) {
            //this is to output default form
            default:
                $iem_xml_path = get_site_option('iem_xml_path');
                $iem_xml_user = get_site_option('iem_xml_username');
                $iem_xml_token = get_site_option('iem_xml_token');
                $field_mapping = get_site_option('iem_mapping');
                ?>
                    <h2><?php _e('IEM User Subscription 2.1 for Wordpress') ?></h2><br/><br/>

                    <form method="post" action="?page=iem&action=process">

                        <h3><?php _e('API Configuration:') ?></h3>

                        <table class="form-table">
                            <tr>
                                <th scope="row"><?php _e('XML Path:') ?></th>
                                <td><input id="xml_path" name="xml_path" type="text" size="50" value="<?php echo $iem_xml_path; ?>" class="regular-text code" /></td>
                            </tr>
                            <tr>
                                <th scope="row"><?php _e('XML Username:') ?></th>
                                <td><input id="xml_username" name="xml_username" type="text" size="20" value="<?php echo $iem_xml_user; ?>" class="regular-text code" /></td>
                            </tr>
                            <tr>
                                <th scope="row"><?php _e('XML Token:') ?></th>
                                <td><input id="xml_token" name="xml_token" type="text" size="40" value="<?php echo $iem_xml_token; ?>" class="regular-text code" /></td>
                            </tr>
                        </table>

                        <br/><br/>

                        <h3><?php _e('Subscribing Setting:') ?></h3>

                        <table class="form-table">
                            <?php
                            $roles = iemus_get_roles();
                            $lists = iemus_get_contact_list($iem_xml_path, $iem_xml_user, $iem_xml_token);
                            if($lists == null) $lists = array();

                            foreach ($roles as $role) { $rolename = $role[name]; ?>
                                <tr>
                                    <th scope="row"><?php echo $rolename;?></th>
                                    <td>
                                        <select id="<?php echo $rolename;?>" name="mapping[<?php echo $rolename;?>][id]" onchange="get_field_mapping_html('#<?php echo $rolename;?>');">
                                            <option value=""></option>
                                            <?php
                                            $selected = 0;
                                            if(isset($field_mapping[$rolename]))
                                                $selected = $field_mapping[$rolename][id];
                                            foreach ($lists as $meta){?>
                                                <option value="<?php echo $meta->listid;?>" <?php echo ($selected == $meta->listid) ? "selected" : "";?>><?php echo "$meta->name ($meta->subscribecount)";?></option>
                                            <?php } ?>
                                        </select>
                                        <a onclick="get_field_mapping_html('#<?php echo $rolename;?>');" class="button button-primary">Edit fields</a>
                                    </td>
                                </tr>
                                <tr>
                                    <td colspan="2" class="iem-pd0"><table class="form-table" id="<?php echo $rolename;?>-mapping-html"></table></td>
                                </tr>
                            <?php } ?>

                        </table>

                        <br/><br/>

                        <p class="submit">
                            <input type="submit" name="Submit" value="<?php _e('Save Changes') ?>" class="button button-primary" />
                        </p>

                    </form>
                    <script type="text/javascript" src="<?php echo plugins_url('iemus/js/iemus_ajax.js');?>"></script>
                    <link rel="stylesheet" href="<?php echo plugins_url('iemus/css/iemus.css');?>"/>
                <?php
                break;

            case "process":

                update_site_option( "iem_xml_path", stripslashes($_POST[ 'xml_path' ]) );
                update_site_option( "iem_xml_username", stripslashes($_POST[ 'xml_username' ]) );
                update_site_option( "iem_xml_token", stripslashes($_POST[ 'xml_token' ]) );
                update_site_option( "iem_mapping", $_POST[ 'mapping' ] );

                echo "<SCRIPT LANGUAGE='JavaScript'>
                window.location='?page=iem&updated=true&updatedmsg=" . urlencode(__('Settings saved.')) . "';
                </script>";

                break;

            case "temp":
                break;
        }
        echo '</div>';
    }

    /*
     * Ajax fields mapping handle
     */
    function iemus_get_mapping_html() {
        $listid = (int)$_POST['id'];
        $role = $_POST['role'];

        $iem_xml_path = get_site_option('iem_xml_path');
        $iem_xml_username = get_site_option('iem_xml_username');
        $iem_xml_token = get_site_option('iem_xml_token');

        $field_mapping = get_site_option('iem_mapping');
        $field_value = $field_mapping[$role][$listid];

        $cfarray = iemus_get_custom_fields_array($iem_xml_path , $iem_xml_username, $iem_xml_token, $listid);
        $wpmetas = iemus_get_metafields();

        $cfarray = ($cfarray == null) ? array() : $cfarray;
        $wpmetas = ($wpmetas == null) ? array() : $wpmetas;

        $html = '';
        if(count($cfarray)) {

            foreach ($cfarray as $item) {
                $fieldid = (int) $item['fieldid'];

                $html.= '<tr><td scope="row" class="iem-w190 iem-tar">'.$item['name'].'</td>';
                $html.= '<td><select name="mapping['.$role.']['. $listid. '][' . $fieldid . ']">
                        <option value=""></option>';
                foreach ($wpmetas as $meta){
                    $html.= '<option value="'. $meta .'" '.($field_value[$fieldid] == $meta ? "selected" : "") . '>' . $meta .'</option>';
                }
                $html.= '</select>';
                $html.= '</td>';
                $html.= '</tr>';
            }
        }

        echo $html;
        die();
    }
}
?>