<?php

global $wp_version;

if (version_compare($wp_version,"3.8.1","<"))
{
    $exit_msg = 'IEM User Subscription 2.1 requires WordPress 3.8.1 or newer. Please upgrade your Wordpress before you can continue';
    exit ($exit_msg);
}

//check for curl enable
if (!function_exists('curl_version')){
    $exit_msg = 'IEM User Subscription 2.1 requires CURL enabled on your server, please enable CURL before you can continue';
    exit ($exit_msg);
}

require 'iemus_iem.php';
require 'iemus_wp.php';
require 'iemus_ajax.php';
require 'iemus_base.php';

$iemus = new IEMus();
add_action('admin_menu', array($iemus, 'iemus_add_menu'));
add_action('wp_ajax_get_mapping_html', array($iemus, 'iemus_get_mapping_html') );
add_action('wpmu_new_user', 'iemus_subscribe');
add_action('user_register', 'iemus_subscribe');

?>